Angular Bootstrap File Input

Angular File Input - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Angular Bootstrap's file input is a field that the user can use to upload one or more files (photos, documents or any other file type) from their local storage.

Standard file inputs usually leave a lot to wish for in terms of design, but MDB takes care of that by enhancing them with Material Design best practices.

Most common use examples:

  • CSV upload to CRM system
  • Avatar picture upload
  • Simple GIF upload

Below you can see a number of Angular Bootstrap file inputs created with Material Design for Bootstrap.


Basic example MDB Pro component

Choose file
        
            
          <form>
            <div class="file-field md-form">
              <div mdbBtn color="primary" size="sm" class="waves-light" mdbWavesEffect>
                <span>Choose file</span>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
            </div>
            <button mdbBtn color="primary" (click)="startUpload()">Start uploading</button>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
          import { humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'file-input-example',
            templateUrl: 'file-input.html',
          })

          export class FileInputComponent  {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
              const event: UploadInput = {
              type: 'uploadAll',
              url: 'your-path-to-backend-endpoint',
              method: 'POST',
              data: { foo: 'bar' },
              };
              this.files = [];
              this.uploadInput.emit(event);
              }

              cancelUpload(id: string): void {
              this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

File input with floating button MDB Pro component

        
            
          <form>
            <div class="file-field md-form">
              <div mdbBtn floating="true" size="md" color="amber" mdbWavesEffect>
                <mdb-icon fas icon="cloud-upload-alt" aria-hidden="true"></mdb-icon>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper mt-3">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
            </div>
            <button mdbBtn type="button" color="amber" class="waves-light" (click)="startUpload()" mdbWavesEffect>Start uploading</button>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
          import { humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'file-input-example',
            templateUrl: 'file-input.html',
          })

          export class FileInputComponent  {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
              const event: UploadInput = {
              type: 'uploadAll',
              url: 'your-path-to-backend-endpoint',
              method: 'POST',
              data: { foo: 'bar' },
              };
              this.files = [];
              this.uploadInput.emit(event);
            }

            cancelUpload(id: string): void {
              this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

File input with gradient floating button MDB Pro component

        
            
          <form>
            <div class="file-field md-form">
              <div mdbBtn floating="true" size="md" gradient="purple" mdbWavesEffect>
                <mdb-icon fas icon="cloud-upload-alt" aria-hidden="true"></mdb-icon>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper mt-3">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
            </div>
            <button mdbBtn type="button" gradient="purple" class="waves-light" (click)="startUpload()" mdbWavesEffect>Start uploading</button>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
          import { humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'file-input-example',
            templateUrl: 'file-input.html',
          })

          export class FileInputComponent  {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
            const event: UploadInput = {
            type: 'uploadAll',
            url: 'your-path-to-backend-endpoint',
            method: 'POST',
            data: { foo: 'bar' },
            };
            this.files = [];
            this.uploadInput.emit(event);
            }

            cancelUpload(id: string): void {
            this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

File input with rounded outline button MDB Pro component

        
            
          <form>
            <div class="file-field md-form">
              <div mdbBtn rounded="true" outline="true" color="secondary" size="md" mdbWavesEffect>
                <span class="pt-1">Choose file</span>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper mt-2">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
            </div>
            <button mdbBtn type="button" rounded="true" outline="true" color="secondary" (click)="startUpload()" mdbWavesEffect>Start uploading</button>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
          import { humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'file-input-example',
            templateUrl: 'file-input.html',
          })

          export class FileInputComponent  {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
              const event: UploadInput = {
              type: 'uploadAll',
              url: 'your-path-to-backend-endpoint',
              method: 'POST',
              data: { foo: 'bar' },
              };
              this.files = [];
              this.uploadInput.emit(event);
              }

              cancelUpload(id: string): void {
              this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

File input with rounded gradient button MDB Pro component

        
            
          <form>
            <div class="file-field md-form">
              <div mdbBtn rounded="true" gradient="aqua" size="md" mdbWavesEffect>
                <span class="pt-1">Choose file</span>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper mt-2">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
            </div>
            <button mdbBtn type="button" rounded="true" gradient="aqua" (click)="startUpload()" mdbWavesEffect>Start uploading</button>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
          import { humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'file-input-example',
            templateUrl: 'file-input.html',
          })

          export class FileInputComponent  {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
              const event: UploadInput = {
              type: 'uploadAll',
              url: 'your-path-to-backend-endpoint',
              method: 'POST',
              data: { foo: 'bar' },
              };
              this.files = [];
              this.uploadInput.emit(event);
            }

            cancelUpload(id: string): void {
              this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

Removing files from file upload queue MDB Pro component

Use the removeFile(id: string) method to remove specific file from upload queue. Use the this.files[index].id property as an method argument.

        
            
            <form>
              <div class="file-field md-form">
                <div mdbBtn rounded="true" gradient="aqua" size="md" mdbWavesEffect>
                  <span class="pt-1">Choose file</span>
                  <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
                </div>
                <div class="file-path-wrapper mt-2">
                  <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
                </div>
              </div>
              <button mdbBtn type="button" rounded="true" gradient="aqua" (click)="startUpload()" mdbWavesEffect>Start uploading
              </button>
              <button mdbBtn type="button" rounded="true" gradient="aqua" (click)="removeFirstFileFromQueue()" mdbWavesEffect>Remove
                file from queue
              </button>
            </form>
          
        
    
        
            
            import { Component, EventEmitter } from '@angular/core';
            import { UploadFile, UploadInput, UploadOutput } from 'ng-uikit-pro-standard';
            import { humanizeBytes } from 'ng-uikit-pro-standard';

            @Component({
              selector: 'file-input-example',
              templateUrl: 'file-input.html',
            })
            export class FileInputComponent {
              formData: FormData;
              files: UploadFile[];
              uploadInput: EventEmitter<UploadInput>;
              humanizeBytes: Function;
              dragOver: boolean;

              constructor() {
                this.files = [];
                this.uploadInput = new EventEmitter < UploadInput > ();
                this.humanizeBytes = humanizeBytes;
              }

              showFiles() {
                let files = '';
                for (let i = 0; i < this.files.length; i++) {
                  files += this.files[i].name;
                  if (!(this.files.length - 1 === i)) {
                    files += ',';
                  }
                }
                return files;
              }

              startUpload(): void {
                const event: UploadInput = {
                  type: 'uploadAll',
                  url: 'your-path-to-backend-endpoint',
                  method: 'POST',
                  data: { foo: 'bar' },
                };
                this.removeFirstFileFromQueue();
                this.files = [];
                this.uploadInput.emit(event);
              }

              cancelUpload(id: string): void {
                this.uploadInput.emit({ type: 'cancel', id: id });
              }

              onUploadOutput(output: UploadOutput | any): void {
                if (output.type === 'allAddedToQueue') {
                } else if (output.type === 'addedToQueue') {
                  this.files.push(output.file); // add file to array when added
                } else if (output.type === 'uploading') {
                  // update current data in files array for uploading file
                  const index = this.files.findIndex(file => file.id === output.file.id);
                  this.files[index] = output.file;
                } else if (output.type === 'removed') {
                  // remove file from array when removed
                  this.files = this.files.filter((file: UploadFile) => file !== output.file);
                } else if (output.type === 'dragOver') {
                  this.dragOver = true;
                } else if (output.type === 'dragOut') {
                } else if (output.type === 'drop') {
                  this.dragOver = false;
                }
                this.showFiles();
              }

              removeFile(id: string): void {
                this.uploadInput.emit({ type: 'remove', id: id });
              }

              removeFirstFileFromQueue() {
                this.removeFile(this.files[0].id);
              }
            }
          
        
    

Using upload options MDB Pro component

        
            
            <form>
              <div class="file-field md-form">
                <div mdbBtn color="primary" size="sm" class="waves-light" mdbWavesEffect>
                  <span>Choose file</span>
                  <input type="file" mdbFileSelect [options]="options" (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
                </div>
                <div class="file-path-wrapper">
                  <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
                </div>
              </div>
              <button mdbBtn color="primary" (click)="startUpload()">Start uploading</button>
            </form>
          
        
    
        
            
            import { Component, EventEmitter } from '@angular/core';
            import { UploadFile, UploadInput, UploadOutput, UploaderOptions } from 'ng-uikit-pro-standard';
            import { humanizeBytes } from 'ng-uikit-pro-standard';

            @Component({
              selector: 'file-input-example',
              templateUrl: 'file-input.html',
            })

            export class FileInputComponent {
              formData: FormData;
              files: UploadFile[];
              uploadInput: EventEmitter<UploadInput>;
              humanizeBytes: Function;
              dragOver: boolean;
              options: UploaderOptions

              constructor() {
                this.options = {
                  concurrency: 1,
                  maxUploads: 2,
                  allowedContentTypes: ['text/plain']
                };
                this.files = [];
                this.uploadInput = new EventEmitter < UploadInput > ();
                this.humanizeBytes = humanizeBytes;
              }

              showFiles() {
                let files = '';
                for (let i = 0; i < this.files.length; i++) {
                  files += this.files[i].name;
                  if (!(this.files.length - 1 === i)) {
                    files += ',';
                  }
                }
                return files;
              }

              startUpload(): void {
                const event: UploadInput = {
                  type: 'uploadAll',
                  url: 'your-path-to-backend-endpoint',
                  method: 'POST',
                  data: { foo: 'bar' },
                };
                this.files = [];
                this.uploadInput.emit(event);
              }

              cancelUpload(id: string): void {
                this.uploadInput.emit({ type: 'cancel', id: id });
              }

              onUploadOutput(output: UploadOutput | any): void {
                if (output.type === 'allAddedToQueue') {
                } else if (output.type === 'addedToQueue') {
                  this.files.push(output.file); // add file to array when added
                } else if (output.type === 'uploading') {
                  // update current data in files array for uploading file
                  const index = this.files.findIndex(file => file.id === output.file.id);
                  this.files[index] = output.file;
                } else if (output.type === 'removed') {
                  // remove file from array when removed
                  this.files = this.files.filter((file: UploadFile) => file !== output.file);
                } else if (output.type === 'dragOver') {
                  this.dragOver = true;
                } else if (output.type === 'dragOut') {
                } else if (output.type === 'drop') {
                  this.dragOver = false;
                }
                this.showFiles();
              }
            }
          
        
    

Angular File Input - API

In this section you will find informations about required modules of file input component.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

        
            
            import { FileInputModule, WavesModule } from 'ng-uikit-pro-standard';
          
        
    

Directives

MdbFileSelect

Selector: mdbFileSelect

Type: MDBFileSelectDirective

MdbFileDrop

Selector: mdbFileDrop

Type: MDBFileDropDirective


Inputs

Name Type Default Description Example
options UploaderOptions - Allow to specify custom upload options [options] = { concurrency: 1, maxUploads: 1, allowedContentTypes: ['text/plain', 'image/jpeg', 'image/png'] };
Uploader options

Custom upload options

Name Type Description
allowedContentTypes string[] Allowed types of uploaded files
concurrency number Number of files uploaded at the same time
maxUploads number Max number of files that can be uploaded

Angular File Input - examples & customization


Uploading file with File Input MDB Pro component

In order to show how to send a file through the File Input component, you need to set up a server. We will use Node + Express.js stack.

If you come across a problem, please check our support forum to see if someone else has already had a similar problem. If not, then feel free to set up a new topic!

The whole project is available at this address as a zip archive.

As a first step, copy the following HTML and TS code into your project.

        
            
          <form>
            <div class="file-field md-form d-flex justify-content-between align-items-center">
              <div mdbBtn floating="true" size="md" color="amber" mdbWavesEffect>
                <mdb-icon fas icon="cloud-upload-alt" aria-hidden="true"></mdb-icon>
                <input type="file" mdbFileSelect (uploadOutput)="onUploadOutput($event)" [uploadInput]="uploadInput">
              </div>
              <div class="file-path-wrapper mt-1">
                <input class="file-path" type="text" placeholder="Upload your file" [value]="showFiles()">
              </div>
              <button mdbBtn type="button" size="sm" color="amber" rounded="true" class="darken-2 waves-light" (click)="startUpload()"
                mdbWavesEffect>Start
                uploading</button>
            </div>
          </form>
        
        
    
        
            
          import { Component, EventEmitter } from '@angular/core';
          import { UploadInput, UploadOutput, UploadFile, humanizeBytes } from 'ng-uikit-pro-standard';

          @Component({
            selector: 'app-root',
            templateUrl: './app.component.html',
            styleUrls: ['./app.component.scss']
          })
          export class AppComponent {
            formData: FormData;
            files: UploadFile[];
            uploadInput: EventEmitter<UploadInput>;
            humanizeBytes: Function;
            dragOver: boolean;

            constructor() {
              this.files = [];
              this.uploadInput = new EventEmitter<UploadInput>();
              this.humanizeBytes = humanizeBytes;
            }

            showFiles() {
              let files = '';
              for (let i = 0; i < this.files.length; i ++) {
                files += this.files[i].name;
                if (!(this.files.length - 1 === i)) {
                  files += ',';
                }
              }
              return files;
            }

            startUpload(): void {
              const event: UploadInput = {
              type: 'uploadAll',
              url: 'http://localhost:3001/api/upload',
              method: 'POST',
              data: { foo: 'bar' },
              };
              this.files = [];
              this.uploadInput.emit(event);
            }

            cancelUpload(id: string): void {
              this.uploadInput.emit({ type: 'cancel', id: id });
            }

            onUploadOutput(output: UploadOutput | any): void {
              if (output.type === 'allAddedToQueue') {
              } else if (output.type === 'addedToQueue') {
                this.files.push(output.file); // add file to array when added
              } else if (output.type === 'uploading') {
                // update current data in files array for uploading file
                const index = this.files.findIndex(file => file.id === output.file.id);
                this.files[index] = output.file;
              } else if (output.type === 'removed') {
                // remove file from array when removed
                this.files = this.files.filter((file: UploadFile) => file !== output.file);
              } else if (output.type === 'dragOver') {
                this.dragOver = true;
              } else if (output.type === 'dragOut') {
              } else if (output.type === 'drop') {
                this.dragOver = false;
              }
              this.showFiles();
            }
          }
        
        
    

Necessary files and folders

In the next step in your application's root directory, create the following folders and the files that they will contain.

  • bin/www.ts,
  • routes/index.ts,
  • uploads,
  • app.ts.
File upload files structure

Necessary libraries and filling up files

The next step is to install the following additional libraries, thanks to which we will handle the sending of the file to the backend, and then complete the previously created files with the required code.

        
            
          npm install --save express body-parser cors multer
        
        
    

Copy the below code into app.ts file

        
            
          const express = require('express');
          const path = require('path');
          const bodyParser = require('body-parser');
          const cors = require('cors');

          const indexRouter = require('./routes/index');
          const app = express();

          const corsOptions = {
            origin: '*',
            optionsSuccessStatus: 200
          };

          app.use(cors(corsOptions));
          app.use(bodyParser.json());
          app.use(bodyParser.urlencoded({ extended: true }));

          // create a cors middleware
          app.use((req, res, next) => {
            // set headers to allow cross origin request.
            res.header('Access-Control-Allow-Origin', '*');
            res.header('Access-Control-Allow-Methods', 'PUT, GET, POST, DELETE, OPTIONS');
            res.header('Access-Control-Allow-Headers', 'Origin, X-Requested-With, Content-Type, Accept');
            next();
          });

          app.use('/api', indexRouter);

          module.exports = app;
        
        
    

Then copy the below code into routes/index.ts file

        
            
          const exp = require('express');
          const router = exp.Router();
          const multer = require('multer');
          const DIR = './uploads/';

          let upload = multer({ dest: DIR }).single('file');

          router.post('/upload', (req, res, next) => {
            let path = '';
            upload(req, res, (err) => {
                if (err) {
                    console.log(err);
                    return res.status(422).send('An error occured');
                }
                path = req.file.path;
                console.log('Uploaded');
                return res.send('Upload completed for ' + path);
            });
          });

          module.exports = router;
        
        
    

And the last .ts file which you have to fill up is bin/www.ts file.

        
            
          #!/usr/bin/env node

          /**
          * Module dependencies.
          */

          const appFile = require('../app');
          const debug = require('debug')('file-upload:server');
          const http = require('http');

          /**
          * Get port from environment and store in Express.
          */

          const port = normalizePort(process.env.PORT || '3001');
          appFile.set('port', port);

          /**
          * Create HTTP server.
          */

          const server = http.createServer(appFile);

          /**
          * Listen on provided port, on all network interfaces.
          */

          server.listen(port);
          server.on('error', onError);
          server.on('listening', onListening);

          /**
          * Normalize a port into a number, string, or false.
          */

          function normalizePort(val) {
            const portNumber = parseInt(val, 10);

            if (isNaN(portNumber)) {
            // named pipe
            return val;
            }

            if (portNumber >= 0) {
            // port number
            return portNumber;
            }

            return false;
          }

          /**
          * Event listener for HTTP server "error" event.
          */

          function onError(error) {
          if (error.syscall !== 'listen') {
            throw error;
          }

          const bind = typeof port === 'string' ?
          'Pipe ' + port :
          'Port ' + port;

          // handle specific listen errors with friendly messages
          switch (error.code) {
            case 'EACCES':
            console.error(bind + ' requires elevated privileges');
            process.exit(1);
            break;
            case 'EADDRINUSE':
            console.error(bind + ' is already in use');
            process.exit(1);
            break;
            default:
            throw error;
          }
          }

          /**
          * Event listener for HTTP server "listening" event.
          */

          function onListening() {
            const addr = server.address();
            const bind = typeof addr === 'string' ?
            'pipe ' + addr :
            'port ' + addr.port;
            debug('Listening on ' + bind);
          }
        
        
    

After you have completed all required files with the above code, add a script to the package.json file, which will run your server.

        
            
          "server": "tsc app.ts && tsc routes/index.ts && tsc bin/www.ts && node ./bin/www.js"
        
        
    

Running the server and testing file upload

At the very end, we have nothing left to do but to run the server and the application. To do this, open two terminal windows, and run the commands npm run server and ng serve in them.

        
            
          npm run server
        
        
    
        
            
          ng serve
        
        
    

Conclusion

The above commands will run two processes - one responsible for server operation and the other for Angular application operation. Now it is enough to select a file and press the Upload button, and after a while, this file will be in your project, in the uploads directory. The name of this file is hashed, so you can avoid duplicate files.

Important note

Please note that a piece of CORS-enabled code is only placed in the development environment. It is not recommended to use this piece of code in a production environment unless you know what you are doing.

React Bootstrap File Input

React File Input - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap file input is a field which user can use to upload one or more files (photos, documents or any other file type) from the local storage.

Standard file inputs usually leave a lot to wish for in terms of design, but MDB takes care of that by enhancing them with Material Design best practices.

Most common use examples:

  • CSV upload to CRM system
  • Avatar picture upload
  • Simple GIF upload

Below you can see a number of Bootstrap file inputs created with Material Design for Bootstrap.


Default file input

Default styling for Bootstrap File Input component

Upload
        
              
            import React, { Component } from "react";

            class InputPage extends Component {

              render() {
                return (
                  <div className="input-group">
                    <div className="input-group-prepend">
                      <span className="input-group-text" id="inputGroupFileAddon01">
                        Upload
                      </span>
                    </div>
                    <div className="custom-file">
                      <input
                        type="file"
                        className="custom-file-input"
                        id="inputGroupFile01"
                        aria-describedby="inputGroupFileAddon01"
                      />
                      <label className="custom-file-label" htmlFor="inputGroupFile01">
                        Choose file
                      </label>
                    </div>
                  </div>
                );
              }
            }

            export default InputPage;

          
        
    

Material file input MDB Pro component

Material Design styling for Bootstrap File Input component

Choose file
        
              
            import React, { Component } from "react";
            import { MDBFileInput } from "mdbreact";

            class InputPage extends Component {

              render() {
                return (
                  <MDBFileInput />
                );
              }
            }

            export default InputPage;

          
        
    

Multiple files input MDB Pro component

Choose files
        
              
          import React, { Component } from "react";
          import { MDBFileInput } from "mdbreact";

          class InputPage extends Component {

          render() {
            return (
                <MDBFileInput multiple btnColor="info" />
              );
            }
          }

          export default InputPage;
        
        
    

React File Input - API

In this section you will find advanced information about the File Input component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

        
            
          import { MDBFileInput } from "mdbreact";
        
        
    

API Reference: MDBInputFile Properties

Name Type Default Description Example
btnColor String primary Specifies button's color. <MDBInputFile btnColor="default" ... />
btnTitle String Choose file Specifies button's title. <MDBInputFile btnTitle="Choose file" ... />
className String Adds custom classes <MDBInputFile className="myClass" ... />
multiple Boolean false Allows to upload multiple files. <MDBInputFile multiple ... />
textFieldTitle String Upload your file Specifies input's placeholder. <MDBInputFile textFieldTitle="Your custom text goes here" ... />
reset Boolean false Adds a reset button. <MDBInputFile reset />
resetClassName String Adds custom class to the reset button. <MDBInputFile resetClassName="myClass" />
resetAriaLabel String Defines a string that labels the reset button element. <MDBInputFile resetAriaLabel="Dismiss" />
reverse Boolean false Lets the button to switch places with input <MDBInputFile reverse ... />

API Reference: MDBInputFile Methods

Name Parameters Description Example
getValue value Returns input value, on onChange event. <MDBInputFile getValue={this.fileInputHandler} />

Vue Bootstrap File Input

Vue File Input - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap file input is a field which user can use to upload one or more files (photos, documents or any other file type) from the local storage.

Standard file inputs usually leave a lot to wish for in terms of design, but MDB takes care of that by enhancing them with Material Design best practices.

Most common use examples:

  • CSV upload to CRM system
  • Avatar picture upload
  • Simple GIF upload

Below you can see a number of Bootstrap file inputs created with Material Design for Bootstrap.


Default file input

Default styling for Bootstrap File Input component

Upload
        
            
          <template>
            <div class="input-group">
              <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroupFileAddon01">Upload</span>
              </div>
              <div class="custom-file">
                <input type="file" class="custom-file-input" id="inputGroupFile01"
                  aria-describedby="inputGroupFileAddon01">
                <label class="custom-file-label" for="inputGroupFile01">Choose file</label>
              </div>
            </div>
          </template>
          
        
    

Material file input MDB Pro component

Material Design styling for Bootstrap File Input component

Choose file
        
            
            <template>
              <mdb-file-input sm btnColor="primary" />
            </template>
            
        
    
        
            
            <script>
              import {
                mdbFileInput
              } from 'mdbvue';
              export default {
                name: "FileInput",
                componens: {
                  mdbFileInput
                }
              }
            </script>
            
        
    

Multiple files input MDB Pro component

Choose files
        
            
        <template>
          <mdb-file-input multiple sm btnColor="primary" />
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput
          } from 'mdbvue';
          export default {
            name: "FileInput",
            componens: {
              mdbFileInput
            }
          }
        </script>
        
        
    

File inputs with photo placeholder MDB Pro component

Add img property to mdb-file-input to display photo placeholder and control a its apperance with circle and width properties

example placeholder
Choose file
example placeholder avatar
Add photo
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col md="4">
                <mdb-file-input @getValue="getFileInputValue" circle btnColor="mdb-color" btn-title="ADD PHOTO" rounded
                  img="https://mdbootstrap.com/img/Photos/Others/placeholder-avatar.webp" />
              </mdb-col>
              <mdb-col md="4">
                <mdb-file-input @getValue="getFileInputValue" :width="300" btnColor="mdb-color" rounded
                  btn-title="ADD PHOTO" img="https://mdbootstrap.com/img/Photos/Others/placeholder.webp" />
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbCol,
            mdbFileInput,
            mdbContainer,
            mdbRow
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbCol,
              mdbFileInput,
              mdbContainer,
              mdbRow
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with gradient floating buttons MDB Pro component

        
            
        <template>
          <mdb-row>
            <mdb-col sm="12" md="4">
              <mdb-file-input @getValue="getFileInputValue" floating icon="paperclip" gradient="peach" />
            </mdb-col>
            <mdb-col sm="12" md="4">
              <mdb-file-input @getValue="getFileInputValue" floating icon="heart" gradient="blue" />
            </mdb-col>
            <mdb-col>
              <mdb-file-input @getValue="getFileInputValue" floating icon="cloud-upload-alt" gradient="purple" />
            </mdb-col>
          </mdb-row>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbCol,
            mdbFileInput,
            mdbRow
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbCol,
              mdbFileInput,
              mdbRow
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with large floating buttons MDB Pro component

        
            
        <template>
          <mdb-row>
            <mdb-col sm="12" md="4">
              <mdb-file-input @getValue="getFileInputValue" floating lg icon="paperclip" btnColor="pink" />
            </mdb-col>
            <mdb-col sm="12" md="4">
              <mdb-file-input @getValue="getFileInputValue" floating lg icon="heart" btnColor="cyan" />
            </mdb-col>
            <mdb-col>
              <mdb-file-input @getValue="getFileInputValue" floating lg icon="cloud-upload-alt" btnColor="amber" />
            </mdb-col>
          </mdb-row>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbCol,
            mdbFileInput,
            mdbRow
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbCol,
              mdbFileInput,
              mdbRow
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with rounded gradient buttons MDB Pro component

Choose file
Choose file
Choose file
        
            
        <template>
          <mdb-container>
            <mdb-file-input @getValue="getFileInputValue" sm rounded gradient="purple" />
            <mdb-file-input @getValue="getFileInputValue" rounded gradient="aqua" />
            <mdb-file-input @getValue="getFileInputValue" rounded lg gradient="peach" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbFileInput,
              mdbContainer
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with rounded outline buttons MDB Pro component

Choose file
Choose file
Choose file
        
            
        <template>
          <mdb-container>
            <mdb-file-input @getValue="getFileInputValue" rounded sm outline="success" />
            <mdb-file-input @getValue="getFileInputValue" rounded outline="secondary" />
            <mdb-file-input @getValue="getFileInputValue" rounded lg outline="warning" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbFileInput,
              mdbContainer
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with colorful buttons MDB Pro component

Choose files
Choose files
Choose files
        
            
        <template>
          <mdb-container>
            <mdb-file-input @getValue="getFileInputValue" sm btnColor="unique" />
            <mdb-file-input @getValue="getFileInputValue" btnColor="light-blue" />
            <mdb-file-input @getValue="getFileInputValue" lg btnColor="primary" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbFileInput,
              mdbContainer
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with outline buttons MDB Pro component

Choose files
Choose files
Choose files
        
            
        <template>
          <mdb-container>
            <mdb-file-input @getValue="getFileInputValue" sm outline="info" />
            <mdb-file-input @getValue="getFileInputValue" outline="default" />
            <mdb-file-input @getValue="getFileInputValue" lg outline="danger" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbFileInput,
              mdbContainer
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs with buttons with icons MDB Pro component

Choose files
Choose file
Choose files
Choose file
        
            
        <template>
          <mdb-row>
            <mdb-col sm="12" md="6">
              <mdb-file-input @getValue="getFileInputValue" icon="cloud-upload-alt" sm gradient="blue" />
              <mdb-file-input @getValue="getFileInputValue" icon="cloud-upload-alt" icon-right sm rounded
                btnColor="pink" />
            </mdb-col>
            <mdb-col>
              <mdb-file-input @getValue="getFileInputValue" icon="cloud-upload-alt" outline="info" />
              <mdb-file-input @getValue="getFileInputValue" icon="upload" icon-right rounded lg outline="danger" />
            </mdb-col>
          </mdb-row>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbFileInput,
            mdbCol,
            mdbRow
          } from "mdbvue";
          export default {
            name: "FileInputPage",
            components: {
              mdbFileInput,
              mdbCol,
              mdbRow
            },
            data() {
              return {
                test: 'Test value'
              };
            },
            methods: {
              getFileInputValue(val) {
                console.log(val);
              }
            }
          };
        </script>
        
        
    

File inputs within cards MDB Pro component

Choose file

Choose files
        
            
      <template>
        <mdb-row>
          <mdb-col sm="12" md="6">
            <mdb-card class="indigo py-4 px-5 z-depth-2">
              <mdb-file-input @getValue="getFileInputValue" icon="cloud-upload-alt" sm outline="white" />
              <mdb-file-input @getValue="getFileInputValue" icon="cloud-upload-alt" sm rounded
                text-field-title="Upload one more" outline="white" />
            </mdb-card>
          </mdb-col>
          <mdb-col sm="12" md="6">
            <mdb-card class="mdb-color lighten-4 py-4 px-5 z-depth-2">
              <mdb-file-input @getValue="getFileInputValue" floating text-white icon="paperclip" gradient="peach" />
              <mdb-file-input @getValue="getFileInputValue" floating text-white icon="paperclip" gradient="peach" />
              <mdb-file-input @getValue="getFileInputValue" floating text-white icon="paperclip" gradient="peach" />
            </mdb-card>
          </mdb-col>
        </mdb-row>
      </template>
      
        
    
        
            
      <script>
        import {
          mdbCol,
          mdbFileInput,
          mdbRow,
          mdbCard
        } from "mdbvue";

        export default {
          name: "FileInputPage",
          components: {
            mdbCol,
            mdbFileInput,
            mdbRow,
            mdbCard
          },
          data() {
            return {
              test: 'Test value'
            };
          },
          methods: {
            getFileInputValue(val) {
              console.log(val);
            },
            resetFileInput() {
              this.$refs.fileInput.reset();
            }
          }
        };
      </script>
      
        
    

File Input - API

In this section you will find advanced information about the File Input component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

        
            
    <script>
      import {
        mdbFileInput
      } from 'mdbvue';
    </script>
    
        
    

API Reference: Properties

Name Type Default Description Example
accept String image/jpeg, image/png, image/tiff Specifies accepted type of files. <mdb-file-input accept="image/png" ... />
btnColor String default Specifies button's color. <mdb-file-input btnColor="primary" ... />
btnTitle String Choose file Specifies button's title. <mdb-file-input btnTitle="Choose Your file" ... />
multiple Boolean false Uploading multiple files. <mdb-file-input multiple ... />
textFieldTitle String Upload your file Specifies input's placeholder. <mdb-file-input textFieldTitle="Upload your files" ... />
rounded Boolean false Changes button's style to rounded. <mdb-file-input rounded />
sm Boolean false Sets button's size to small. <mdb-file-input sm />
lg Boolean false Sets button's size to large. <mdb-file-input lg />
outline Boolean false Sets button's style to outline. <mdb-file-input outline />
floating Boolean false Sets button's style to floating. <mdb-file-input floating />
gradient String Sets button's background to gradient. <mdb-file-input gradient="peach" />
icon String Displays an icon on the left. <mdb-file-input icon="upload" />
iconRight String Displays an icon on the right. <mdb-file-input icon-right="upload" />
img Boolean Changes file input's display to image placeholder <mdb-file-input img />
src String "https://mdbootstrap.com/img/Photos/Others/placeholder.webp" Sets source of image placeholder <mdb-file-input img src="https://mdbootstrap.com/img/Photos/Others/placeholder.webp" />
circle Boolean false Changes an image placeholder's style to circle. A source image should have ratio 1:1 to avoid distortion. <mdb-file-input img circle />
width Number 150 Sets width of an image placeholder (in pixels). <mdb-file-input img :width="130" />

API Reference: Methods

Name Parameters Description Example
v-on:getValue value Returns input value. Use this method instead of v-model to handle input value changes. <mdb-file-input @getValue="getFileInputValue" />